<?php

namespace Drupal\tmgmt_wordsonline\Common;

use Drupal\Core\Archiver\Zip;
use Drupal\Core\Archiver\ArchiverException;

class ZipHandle{
   public $zipPath;
   public $fileContent;
  /**
   * constructor
   *
   */
   public function __construct($zip_path) {
        $this->zipPath = $zip_path;
        $this->fileContent = [];
        $this->unzip_file($zip_path);
    }
   /**
   * unzip file and get contents
   *
   */
    public  function unzip_file($file_path) {
      try {
        $zip = \Drupal::service('plugin.manager.archiver')->getInstance(['filepath' => $file_path]);
        $zip->extract('temporary://tmgmt_wordsonline/');

        $files =$zip->listContents();
        $total = count($files);
        for ($i=0; $i<$total; $i++) {
            $tempPath = "temporary://tmgmt_wordsonline/$files[$i]";
            $content =file_get_contents($tempPath);
            $this->fileContent[] =$this->handle_content($content) ;
            \Drupal::service('file_system')->delete($tempPath);
        }
      }
      catch (ArchiverException $exception) {
        watchdog_exception('tmgmt_wordsonline', $exception);
      }
    
    }
   /**
   * handle content
   *
   */
    public function handle_content($content){
        if($content == null || empty($content)){
            return $content;
        }
        $content = html_entity_decode($content);
        $content = $this->replace_bpt($content , 0);
        $content = $this->replace_ept($content , 0);
       
        return $content;
    }
    /**
   * encode content inside bpt tag
   *
   */
    public function replace_bpt($content, $index =0){
          $bptIndex  = strpos($content,"<bpt",$index);
          if($bptIndex > 0){
            $endBptIndex = strpos($content,"</bpt>",$index);
            $subXml = substr($content, $bptIndex,$endBptIndex - $bptIndex +6);
            $len = strlen($subXml);
            $subLen = $len -6;
            $sIndex = strpos($subXml,">");
            $tempAdd = 0;
            if($subLen > $sIndex +1){
                $temp =$subXml;
                for($i = $sIndex + 1; $i < $subLen; $i++){
                    if($subXml[$i] == '<'){
                        $temp = substr($temp,0,$i+$tempAdd) . '&lt;'.substr($temp,$i + 1 + $tempAdd);
                        $tempAdd = $tempAdd + 3;
                    }
                    if($subXml[$i] == '>'){
                        $temp = substr($temp,0,$i+$tempAdd) . '&gt;'.substr($temp,$i + 1 + $tempAdd);
                        $tempAdd = $tempAdd + 3;
                    }
                }
                $content = substr($content,0,$bptIndex) . $temp . substr($content,$endBptIndex + 6);
                $index = $endBptIndex + 7;
                return $this->replace_bpt($content, $index);
            }
          }
          return $content;
    }
   /**
   * encode content inside ept tag
   *
   */
    public function replace_ept($content, $index =0){
        $eptIndex  = strpos($content,"<ept",$index);
        if($eptIndex > 0){
          $endEptIndex = strpos($content,"</ept>",$index);
          $subXml = substr($content,$eptIndex, $endEptIndex - $eptIndex +6);
          $len = strlen($subXml);
          $subLen = $len -6;
          $sIndex = strpos($subXml,">");
          $tempAdd = 0;
          if($subLen > $sIndex +1){
              $temp =$subXml;
              for($i = $sIndex + 1; $i < $subLen; $i++){
                  if($subXml[$i] == '<'){
                      $temp = substr($temp,0,$i+$tempAdd) . '&lt;'.substr($temp,$i + 1 + $tempAdd);
                      $tempAdd = $tempAdd + 3;
                  }
                  if($subXml[$i] == '>'){
                      $temp = substr($temp,0,$i+$tempAdd) . '&gt;'.substr($temp,$i + 1 + $tempAdd);
                      $tempAdd = $tempAdd + 3;
                  }
              }
              $content = substr($content,0,$eptIndex) . $temp . substr($content,$endEptIndex + 6);
              $index = $endEptIndex + 7;
              return $this->replace_ept($content, $index);
          }
        }
        return $content;
  }
}