<?php

namespace Drupal\tmgmt_wordsonline\Controller;

use Drupal\Core\Ajax\AjaxResponse;
use Drupal\Core\Ajax\OpenModalDialogCommand;
use Drupal\Core\Controller\ControllerBase;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\HttpFoundation\JsonResponse;
use Drupal\Component\Serialization\Json;
use Drupal\tmgmt_wordsonline\WordsOnlineConst;
use Drupal\tmgmt\ContinuousTranslatorInterface;
use Drupal\tmgmt\Entity\Job;
use Drupal\tmgmt\Entity\RemoteMapping;
use Drupal\tmgmt\JobItemInterface;
use Drupal\tmgmt\JobInterface;
use Drupal\Core\Render\Element;
use Drupal\Component\Utility\Html;
use Drupal\Core\Messenger\MessengerTrait;
use Drupal\tmgmt_wordsonline\Entity\WOFile;
use Drupal\Component\Render\FormattableMarkup;
use Drupal\tmgmt_wordsonline\Common\ZipHandle;
use Drupal\tmgmt_wordsonline\WordsOnlineState;
use Drupal\tmgmt_wordsonline\WordsOnlineStatus;
class OrderController extends ControllerBase {
  use MessengerTrait;
  /**
  * open confirm form
  *
  */
  public function openMyModal(Request $request) {
    if ($request->query->get('job_id')) {
      $job_ids = $request->query->get('job_id');
    }
    else {
      // First get all translator IDs that use wordsonline.
      $wordsonline_translator_ids = array_keys(array_filter($translators, function (TranslatorInterface $translator) {
      $translator_plugin = $translator->getPlugin();
      return $translator_plugin instanceof WordsOnlineTranslator;
      }));  
      // Then fetch all active or continuous jobs using those translators.
      $job_ids = \Drupal::entityQuery('tmgmt_job')
                        ->condition('translator', $wordsonline_translator_ids, 'IN')
                        ->condition('state', [JobInterface::STATE_ACTIVE, JobInterface::STATE_CONTINUOUS], 'IN')
                        ->execute();
    }
    $allowSubmmit = 'true';
    if ($request->query->get('allowSubmmit')) {
      $allowSubmmit = $request->query->get('allowSubmmit');
    }    
    $modal_form = $this->formBuilder()->getForm('\Drupal\tmgmt_wordsonline\Form\OrderConfirmForm',$allowSubmmit,$job_ids);
    $render['form'] = $modal_form;

    return $render;
  }
  /**
  * check quote status
  *
  */
  public function checkQuoted(Request $request){
    $has_change =FALSE;
    $key= null;
    if($request->query->get('key')){
     $key =$request->query->get('key');
    }
   $top = "10";
   $skip =0;
   if($request->query->get('page')){
     $skip =$request->query->get('page');
    }
    if($request->query->get('top')){
       $top =$request->query->get('top');
    }
    $list = $this->getDataList($key,$skip,$top);
    if($list != null ){
      $data = $list->list;
      
      $count = $list->count;
      if($count >0){
        $conn = \Drupal\Core\Database\Database::getConnection();
        foreach ($data as $row) {
          $results = \Drupal::database()->query("SELECT request_guid,job_id,status FROM tmgmt_wordsonline_jobs WHERE request_guid =:request_guid  LIMIT 1 ",[':request_guid' =>(string)$row->requestGuid])->fetchAssoc();
          if($results != null){
            $job_id = $results["job_id"];
            $status = $results["status"];
            if($row->state == WordsOnlineState::AutomationFailed && $status !=WordsOnlineConst::JOB_AUTOMATION_FAILED ){
              $conn->update(WordsOnlineConst::JOB_TABLE)
                   ->condition('job_id', $job_id) 
                   ->fields(['status' => WordsOnlineConst::JOB_AUTOMATION_FAILED])
                   ->execute();
              $has_change =TRUE;
              continue;
            }
            if($row->state == WordsOnlineState::QuoteSubmitted && ($row->status == WordsOnlineStatus::Unpaid || $row->status = WordsOnlineStatus::QuoteSubmitted) && $status != WordsOnlineConst::JOB_QUOTED ){
              $conn->update(WordsOnlineConst::JOB_TABLE)
                   ->condition('job_id', $job_id) 
                   ->fields(['status' => WordsOnlineConst::JOB_QUOTED])
                   ->execute();
              $has_change =TRUE;
              continue;
            }
            if($row->status == WordsOnlineStatus::Delivered || $row->status == WordsOnlineStatus::IMPORT_FAIL_STATUS)
            {
              if( $status != WordsOnlineConst::JOB_DELIVERED && $status != WordsOnlineConst::JOB_IMPORTED && $status != WordsOnlineConst::JOB_FINISHED){
                $has_change =TRUE;
                continue;
              }
            }
            $job = Job::load($job_id);
            if($job){
              $state = $job->getState();
              if($state == WordsOnlineConst::STATE_FINISHED && $row->status != WordsOnlineStatus::FINISHED_STATUS){
                $has_change =TRUE;
                continue;
              }
            }
         }
        }
      }
    }
    return new JsonResponse(["status"=>'success','changed'=> $has_change]);
  }
  /**
  * display list wordsonline job
  *
  */
  public function jobList(Request $request){
    $key= null;
    if($request->query->get('key')){
     $key =$request->query->get('key');
    }
    $top = "10";
    $skip =0;
    if($request->query->get('page')){
      $skip =$request->query->get('page');
    }
    if($request->query->get('top')){
      $top =$request->query->get('top');
    }
    $header = [
      'id' => $this->t('Id'),
      'label' => $this->t('Label'),
      'project_name' => $this->t('Project Name'),
      'request_id' =>  $this->t('Request Id'),
	    'request_name' => $this->t('Request Name'),
      'lang_name' => $this->t('Language'),
      'due_date' => $this->t('Due Date'),
	    'status'=> $this->t('Status'),
	    'opt' =>$this->t('Operations')
    ];
    $form['#prefix'] = "<div><a id='btnRefresh'  href='#' class='wol-btn btn-layout'>Refresh Page</a> </div> <div id='wol-loader'></div>";
    $list = $this->getDataList($key,$skip,$top);
     
     $rows=[];
     $count =0;
     $pageCount =0;
    if($list != null ){
      $data = $list->list;
      $count = $list->count;
      if($count%10 >0){
        $pageCount =$count/10+1;
      }else{
        $pageCount =$count/10;
      }
      $configs = \Drupal::database()->query(WordsOnlineConst::SELECT_CONFIG)->fetchAssoc(); 
      if($configs != null){
           $auth["username"] = $configs["username"];
           $auth["password"] = $configs["password"];
           $auth["scope"] = $configs["scope"];
           $auth["grant_type"] =$configs["grant_type"];
      }
      $results = \Drupal::database()->query('SELECT request_guid,job_id,status FROM tmgmt_wordsonline_jobs order by job_id desc ')->fetchAll();
      $conn = \Drupal\Core\Database\Database::getConnection();

      foreach ($data as $row) {
        $job_id ='';
        $operation ='';
        $due_date ='';
        $label ='';
        $status = WordsOnlineConst::NOT_AVAILABLE;
        foreach ($results as $res){
           if($res->request_guid == $row->requestGuid){      
            $job_id = $res->job_id;
            $job = Job::load($job_id);
            if($job){
              $label = $job->label();
              $status = $row->status;
              $due_date = $job->getSetting('due_date');
              $state = $job->getState();
              $jobItems = array_values($job->getItems()) ;

              if($state == WordsOnlineConst::STATE_FINISHED ){
                if( $row->status != WordsOnlineStatus::FINISHED_STATUS){
                  $response = getToken('POST', $auth);
                  $response = json_decode($response, TRUE);
                  $token =$response['access_token'];
                  requestAction($row->requestGuid,WordsOnlineStatus::FINISHED_STATUS,"",$token);
                  $status = WordsOnlineStatus::FINISHED_STATUS;
                }
                if(count($jobItems)>1){
                  $url =  base_path().'admin/tmgmt/jobs/'.$job_id;
                }else{
                   $url =  base_path().'admin/tmgmt/items/'.$jobItems[0]->id().'?destination='. base_path().'admin/tmgmt/jobs/' . $job_id;
                }
                $edit = $url;
                $edit_link  = t( WordsOnlineConst::VIEW_JOB_LINK, array(
                 ':url' => $edit ,
                ));
                $operation = $edit_link;

                $conn->update(WordsOnlineConst::JOB_TABLE)
                     ->condition('job_id', $job_id) 
                     ->fields(['status' => WordsOnlineConst::JOB_FINISHED])
                     ->execute();
                break;
              }
              if($row->state == WordsOnlineState::AutomationFailed){
                $conn->update(WordsOnlineConst::JOB_TABLE)
                     ->condition('job_id', $job_id) 
                     ->fields(['status' => WordsOnlineConst::JOB_AUTOMATION_FAILED])
                     ->execute();
                $status = WordsOnlineConst::JOB_AUTOMATION_FAILED;
                  break;
              }

              if($row->status == "In Progress"){
                $edit = base_path().WordsOnlineConst::CONFIRM_ORDER_LINK.$job_id.'&allowSubmmit=false';
                $edit_link  = t(WordsOnlineConst::VIEW_QUOTE_LINK, array(
                ':url' =>$edit ,
                ));
                $operation = $edit_link;
                $conn->update(WordsOnlineConst::JOB_TABLE)
                     ->condition('job_id', $job_id) 
                     ->fields(['status' => WordsOnlineConst::JOB_QUOTED])
                     ->execute();
                break;
              }
              if($row->state == WordsOnlineState::QuoteSubmitted && ($row->status == WordsOnlineStatus::Unpaid || $row->status = WordsOnlineStatus::QuoteSubmitted)){              
                $edit = base_path().WordsOnlineConst::CONFIRM_ORDER_LINK.$job_id;
                $edit_link  = t(WordsOnlineConst::VIEW_QUOTE_LINK, array(
                ':url' =>$edit ,
                ));
                $operation = $edit_link;
                $conn->update(WordsOnlineConst::JOB_TABLE)
                     ->condition('job_id', $job_id) 
                     ->fields(['status' => WordsOnlineConst::JOB_QUOTED])
                     ->execute();
                break;
              }
              if($row->state == WordsOnlineState::PaymentFailed && ($row->status == WordsOnlineStatus::Unpaid || $row->status = WordsOnlineStatus::QuoteSubmitted)){
                $edit = base_path().WordsOnlineConst::CONFIRM_ORDER_LINK.$job_id;
                $edit_link  = t(WordsOnlineConst::VIEW_QUOTE_LINK, array(
                ':url' =>$edit ,
                ));
                $operation = $edit_link;
                break;
              }
              if( $res->status == WordsOnlineConst::JOB_IMPORTED ){
                if( $row->status != WordsOnlineStatus::IMPORTED_STATUS){
                  $response = getToken('POST', $auth);
                  $response = json_decode($response, TRUE);
                  $token =$response['access_token'];
                  requestAction($row->requestGuid,WordsOnlineStatus::IMPORTED_STATUS,"",$token);
                  $status = WordsOnlineStatus::IMPORTED_STATUS;
                }
                $edit_link = '';
                if(count($jobItems) > 1){
                    $url=  base_path().'admin/tmgmt/jobs/'.$job_id;
                }else{
                     $url=  base_path().'admin/tmgmt/items/'.$jobItems[0]->id().'?destination='. base_path().'admin/tmgmt/jobs/' . $job_id;
                }
                $edit = $url;
                $edit_link  = t(WordsOnlineConst::REVIEW_LINK, array(
                ':url' =>$edit ,
                ));
                $down = base_path().WordsOnlineConst::VIEW_XLF_LINK.$job_id;
                $download_link  = t(WordsOnlineConst::DOWNLOAD_LINK, array(
                ':url' =>$down ,
                ));
                $upload_link =t('<a  class="btn" onclick="reimport('.$job_id.')"  title="Reimport">Reimport</a>');
                $operation = t('@linkApprove  @linkView  @linkUpload', array('@linkApprove' => $edit_link,  '@linkView' =>$download_link, '@linkUpload' =>$upload_link));
                break;
              }

              if(  $row->status == WordsOnlineStatus::Delivered || $row->status == WordsOnlineStatus::IMPORT_FAIL_STATUS)
              {
                  if( $res->status != WordsOnlineConst::JOB_DELIVERED){
                    $conn->update( WordsOnlineConst::JOB_TABLE )
                         ->condition('job_id', $job_id) 
                         ->fields(['status' => WordsOnlineConst::JOB_DELIVERED])
                         ->execute();
                  }
                  $edit_link='';
                  $down =  base_path().WordsOnlineConst::VIEW_XLF_LINK.$job_id;
                  $download_link  = t(WordsOnlineConst::DOWNLOAD_LINK, array(
                   ':url' =>$down ,
                  ));
                   $upload_link = t('<a  class="btn" onclick="reimport('.$job_id.')"  title="Import">Import </a>');
                   $operation = t('@linkApprove  @linkView  @linkUpload', array('@linkApprove' => $edit_link,  '@linkView' =>$download_link, '@linkUpload' =>$upload_link));

              }
              break;
             }
            }
          
        }
        $rows[]=[
          'id'=>$job_id,
          'label' =>$label,
          'project_name' => $row->projectId,
          'request_id' => $row->requestId,
          'request_name' => $row->requestName,
          'lang_name' => $row->sourceLanguage.' > '.$row->targetLanguage,
          'due_date' =>$due_date,
          'status' => $status,
          'opt' =>$operation
        ];     
      }
     }
     $markup = new FormattableMarkup('<div class="wol-search-field">',[]);
     $form['searh_prefix'] = [
               '#markup' => $markup,
          ];
     $form['searh_data'] = [
      '#type' => 'textfield',
      '#name' => 'job_data' ,
      '#value' =>  $key,
      '#description' => t(WordsOnlineConst::SEARCH_PLACEHOLDER),
      '#placeholder' => WordsOnlineConst::SEARCH_PLACEHOLDER,
    ];
   
    $form['actions'] = [
      '#type' => 'button',
      '#value' => $this->t('Search'),
      '#name' => 'job-search' ,
      '#attributes'=>array('class'=> array('btn','btn-layout','ml-3','wol-btn' ),'onclick'=>'searchJob()'),
  ];
    $pageLimits = array();
    $pageLimits["10"] = "10";
    $pageLimits[ "15"] = "15";
    $pageLimits[ "20"] = "20";
    $pageLimits["25"] = "25";
    $form['page_limit'] = array(
      '#type' => 'select',
      '#required' => TRUE,
      '#name' => 'job_page' ,
      '#default_value' =>  $top,
      '#options' => $pageLimits,
      '#attributes'=>array('onchange'=>'changePageLimit()'),
    );
    $markup = new FormattableMarkup('</div>',[]);
    $form['searh_surfix'] = [
            '#markup' => $markup,
      ];
	  $form['table'] = [
      '#type' => 'table',
      '#header' => $header,
      '#rows' => $rows,
      '#empty' => $this->t('No records found'),
      '#attributes'=>array('class'=> array('wol-table')),
    ];

    $form['pager'] = [
      '#type' => 'pager'
    ];
    $pagging ="<div class='pagination'>";
    if($pageCount>0){
      $pagging =$pagging."<a href='#' onclick='goPage(1)'>&laquo;</a>";
      if($skip == '' || $skip == null){
        $skip =1;
      }
      for ($i = 1; $i <= $pageCount; $i++) {
        $active= '';
        if($i== $skip){
          $active ='active';
        }
        $pagging = $pagging."<a class='$active' href='#' onclick='goPage($i)'>".$i."</a>";
        }
        $pagging=$pagging."<a href='#'  onclick='goPage($pageCount)'>&raquo;</a></div>";
    }
    $pagging =$pagging.'</div>';
    $markup = new FormattableMarkup($pagging,[]);
    $form['info_prefix'] = [
              '#markup' => $markup,
      ];
  
    $form['#attached']['library'][] = 'tmgmt_wordsonline/wordsonline_job'; 
    return $form;
  }

  /**
   * get list requests
   *
   */
  public function getDataList( $filter ,$skip,$top='10'){
    $page=0;
    if($skip!=null&& $skip!=''){
       $page=(int) $skip;
       if($page>0){
        $page =$page -1;
       }
     }
    $page =$page * 10;

    $results = \Drupal::database()->query(WordsOnlineConst::SELECT_CONFIG)->fetchAssoc(); 
    if($results != null){
        $auth["username"] = $results["username"];
        $auth["password"] = $results["password"];
        $auth["scope"] = $results["scope"];
        $auth["grant_type"] =$results["grant_type"];
 
        $response = getToken('POST', $auth);
        $response = json_decode($response, TRUE);
        $token =$response['access_token'];
        $url = WordsOnlineConst::API_URL  . 'requests/GetRequests?$skip='.$page.'&$top='.$top.'&$orderby=CreatedAt desc ';
        if($filter!=null&& $filter!=''){
        $searchId ='or contains(tolower(ProjectId),tolower(%27'.$filter.'%27)) ';
        if(is_numeric($filter)){
          $searchId =' or RequestId eq  '.$filter.' ';
        }
        $url= $url.'&$filter=(contains(tolower(TargetLanguage),tolower(%27'.$filter.'%27)) or contains(tolower(SourceLanguage),tolower(%27'.$filter.'%27)) or contains(tolower(RequestName),tolower(%27'.$filter.'%27))  '.$searchId.')';
        }
        $result = \Drupal::httpClient()->get($url, [
          'headers' => [
            'Authorization' => 'Bearer '.$token,
            'Accept' => 'application/json',
            'Referer'=>'ClientAPI'
          ],
          'timeout'=>3600
        ]);
         
        if ($result->getStatusCode() == 200) {
          $data = json_decode($result->getBody()->getContents());
          if($data->status == 1){
            return $data->result;
          }
           
        }
    }
    return null;
    
  }
  /**
   * get  quote info for job
   *
   */
  public function getQuote(Request $request){
    $res["status"]="error";
    if ($request->query->get('job_id')) {
      $job_id = $request->query->get('job_id');

    $results = \Drupal::database()->query(WordsOnlineConst::SELECT_CONFIG)->fetchAssoc(); 
    if($results != null){
      $auth["username"] = $results["username"];
      $auth["password"] = $results["password"];
      $auth["scope"] = $results["scope"];
      $auth["grant_type"] =$results["grant_type"]; 
      $response = getToken('POST', $auth);
      $response = json_decode($response, TRUE);
      $token =$response['access_token'];
      $req = \Drupal::database()->query("SELECT  * FROM tmgmt_wordsonline_jobs where job_id =:job_id LIMIT 1",[':job_id' =>$job_id])->fetchAssoc(); 
          
      if($req!=null){
        $quotes =  getQuote($req['request_guid'],$token);
        if($quotes!=null && $quotes->status== 1){
            $res["status"]="success";
            $res["data"]=$quotes->result;
          }
      }
      return new JsonResponse($res);
    }else{
      return new JsonResponse($res);
    }
    }else{
      return new JsonResponse($res);
    }
    
  }
  /**
   * check has delivery files
   *
   */
  public function CheckHasFiles(){  
    $ret = \Drupal::database()->query(WordsOnlineConst::SELECT_CONFIG)->fetchAssoc(); 
    if($ret != null){
        $auth["username"] = $ret["username"];
        $auth["password"] = $ret["password"];
        $auth["scope"] = $ret["scope"];
        $auth["grant_type"] =$ret["grant_type"];
 
        $response = getToken('POST', $auth);
        $response = json_decode($response, TRUE);
        $token =$response['access_token'];
        $database = \Drupal::database();
        $results =  $database->select(WordsOnlineConst::JOB_TABLE, 'wol');
        $results->fields('wol');
        $results->condition('wol.status',[WordsOnlineConst::JOB_ORDERED,WordsOnlineConst::JOB_DELIVERED],'in');
        $results->orderBy('wol.job_id','DESC');
        $res = $results->execute()->fetchAll();
        $conn = \Drupal\Core\Database\Database::getConnection();
        $has_change = false;
        foreach ($res as $row){
          $files = getRequestFilesList($row->request_guid,$token);
          if($files!=null){              
            if($files->result!=null && count($files->result)>0){
              $job = Job::load($row->job_id);
              if($job){
                $auto_import =$job->getSetting('auto_import');
                $translator = $job->getTranslator();
                $translator->setSetting('xliff_processing', TRUE);
                $translator->save();
                $is_auto=$translator->isAutoAccept();
                if($row->status == WordsOnlineConst::JOB_ORDERED ){
                  $has_change = true;
                }
                if($auto_import == true || $is_auto == true ||$is_auto == 1){
                  $is_import= false;
                      
                  $conn->update(WordsOnlineConst::JOB_TABLE)
                       ->condition('job_id', $row->job_id) 
                       ->fields(['status' => WordsOnlineConst::JOB_DELIVERED])
                       ->execute();

                  foreach($files->result as $fi){
                    $file_guid =$fi->guid;
                    $data= downloadFile($row->request_guid,$file_guid,$token);
                    $fName ="public://".$fi->name;
                    file_put_contents($fName, $data);
                    $zip =new ZipHandle($fName);
                    $fileContent=$zip->fileContent ;
                    \Drupal::service('file_system')->delete($fName);
                    if ( $fileContent != null && count( $fileContent) > 0 && !$this->importTranslation($job, $fileContent[0])){
                      $this->sendErrorToWO($row->request_guid,$fileContent[0],$token);
                    }else{
                      if($is_auto == true ||$is_auto == 1){
                        requestAction($row->request_guid,WordsOnlineStatus::FINISHED_STATUS,"",$token);
                        $conn->update(WordsOnlineConst::JOB_TABLE)
                             ->condition('job_id', $job_id) 
                             ->fields(['status' => WordsOnlineConst::JOB_FINISHED])
                             ->execute();
                      }else{
                        requestAction($row->request_guid,WordsOnlineStatus::IMPORTED_STATUS,"",$token);
                        $conn->update(WordsOnlineConst::JOB_TABLE)
                             ->condition('job_id', $job_id) 
                             ->fields(['status' => WordsOnlineConst::JOB_IMPORTED])
                             ->execute();
                          }
                         $is_import= true;
                        }
                      }
                      if($is_import){
                        $has_change = true;
                      }
                    
                    }else{
                      $conn->update(WordsOnlineConst::JOB_TABLE)
                           ->condition('job_id', $row->job_id) 
                           ->fields(['status' => WordsOnlineConst::JOB_DELIVERED])
                           ->execute();
                    }
                  }
                }
            }
           
          }
          return new JsonResponse(["status"=>'success','changed'=>$has_change]);
      }else{
        \Drupal::messenger()->addError(t('Cannot find WordsOnline provider settings. Please contact <a href="mailto:helpdesk@wordsonline.com"> helpdesk@wordsonline.com</a> to obtain WordsOnline provider settings.'));
        return new JsonResponse(["status"=>'error','changed'=> false]);
      }
   
  }
  /**
   * Imports the given translation data.
   *
   * @param \Drupal\tmgmt\JobInterface $job
   *   The job to import translations for.
   * @param string $translation
   *   The translation data.
   *
   * @throws \Drupal\Component\Plugin\Exception\PluginException
   *   Throws an exception if XLF plugin does not exist.
   * @throws \Drupal\tmgmt\TMGMTException
   *   Throws an exception in case of a neeror.
   */
  public function importTranslation(JobInterface $job, $translation) {
    /** @var \Drupal\tmgmt_file\Plugin\tmgmt_file\Format\Xliff $xliff */
    $xliff = \Drupal::service('plugin.manager.tmgmt_file.format')->createInstance('xlf');
    if (!$xliff->validateImport($translation, FALSE)) {
      return false;
    }

    if ($data = $xliff->import($translation, FALSE)) {
      $job->addTranslatedData($data, NULL, TMGMT_DATA_ITEM_STATE_TRANSLATED);
      $job->addMessage('The translation has been received.');
    }
    else {
      return false;
    }
    return true;
  }
/**
   * set request fail and send mail
   *
   */
  public function sendErrorToWO($request_guid,$xmlData,$token){
    $messages =   getErrorMessage($xmlData);
    requestAction($request_guid,WordsOnlineStatus::IMPORT_FAIL_STATUS,$messages,$token);
    
  }
  /**
   * import file
   *
   */
  public function reimport(Request $request){
    if ($request->query->get('job_id')) {
      $job_id = $request->query->get('job_id');
      $ret = \Drupal::database()->query(WordsOnlineConst::SELECT_CONFIG)->fetchAssoc(); 
      if($ret != null){
        $auth["username"] = $ret["username"];
        $auth["password"] = $ret["password"];
        $auth["scope"] = $ret["scope"];
        $auth["grant_type"] =$ret["grant_type"];
    
        $response = getToken('POST', $auth);
        $response = json_decode($response, TRUE);
        $token =$response['access_token'];
        $request = \Drupal::database()->query("SELECT  * FROM tmgmt_wordsonline_jobs WHERE job_id =:job_id LIMIT 1",[':job_id'=>$job_id])->fetchAssoc();
 
        if($request!=null){            
          $files = getRequestFilesList($request['request_guid'],$token);
          if($files!=null){
              if($files->result!=null && count($files->result)>0){
                $conn = \Drupal\Core\Database\Database::getConnection();
                $status ='downloaded';
                $job = Job::load($job_id);
                if($job){
                  $is_import= false;
                  $translator = $job->getTranslator();
                  $translator->setSetting('xliff_processing', TRUE);
                  $translator->save();
                  $is_auto=$translator->isAutoAccept();
                  foreach($files->result as $fi){
                    $file_guid =$fi->guid;
                    $data= downloadFile($request['request_guid'],$file_guid,$token);
                    $fName ="public://".$fi->name;
                    file_put_contents($fName, $data);
                    $zip =new ZipHandle($fName);
                    $fileContent=$zip->fileContent ;
                    \Drupal::service('file_system')->delete($fName);
                    if ( $fileContent != null && count( $fileContent) > 0 && !$this->importTranslation($job, $fileContent[0])){
                      $this->sendErrorToWO($request['request_guid'],$fileContent[0],$token);
                    }else{
                      if($is_auto == true ||$is_auto == 1){
                        requestAction($request['request_guid'],WordsOnlineStatus::FINISHED_STATUS,"",$token);
                        $conn->update(WordsOnlineConst::JOB_TABLE)
                             ->condition('job_id', $job_id) 
                             ->fields(['status' => WordsOnlineConst::JOB_FINISHED])
                             ->execute();
                      }else{
                        requestAction($request['request_guid'],WordsOnlineStatus::IMPORTED_STATUS,"",$token);
                        $conn->update(WordsOnlineConst::JOB_TABLE)
                             ->condition('job_id', $job_id) 
                             ->fields(['status' => WordsOnlineConst::JOB_IMPORTED])
                             ->execute();
                        }
                        $is_import= true;
                    }
                  }
                  if($is_import){
                        $status ='success';
                  }
                }
                return new JsonResponse(["status"=>$status]);
              }
            }

          }
      }else{
        \Drupal::messenger()->addError(t('Cannot find WordsOnline provider settings. Please contact <a href="mailto:helpdesk@wordsonline.com"> helpdesk@wordsonline.com</a> to obtain WordsOnline provider settings.'));
      }
    }
    return new JsonResponse(["status"=>'error']);
  }
  /**
   * display xlf file for review
   *
   */
  public function viewXlf(Request $request){
    $xmlData = [];
    if ($request->query->get('job_id')) {
      $job_id = $request->query->get('job_id');
     
      $ret = \Drupal::database()->query(WordsOnlineConst::SELECT_CONFIG)->fetchAssoc(); 
      if($ret != null){
        $auth["username"] = $ret["username"];
        $auth["password"] = $ret["password"];
        $auth["scope"] = $ret["scope"];
        $auth["grant_type"] =$ret["grant_type"];
        $response = getToken('POST', $auth);
        $response = json_decode($response, TRUE);
        $token =$response['access_token'];
        $request = \Drupal::database()->query("SELECT  * FROM tmgmt_wordsonline_jobs WHERE job_id =:job_id LIMIT 1",[':job_id' =>$job_id])->fetchAssoc();
        if($request!=null){
          $files = getRequestFilesList($request['request_guid'],$token);
          if($files!=null){
           foreach($files->result as $fi){
             $file_guid =$fi->guid;
             $data= downloadFile($request['request_guid'],$file_guid,$token);
             $fName ="public://".$fi->name;
             file_put_contents($fName, $data);
             $zip =new ZipHandle($fName);
             $fileContent=$zip->fileContent ;
             \Drupal::service('file_system')->delete($fName);
             $content ='';
             if ( $fileContent != null && count( $fileContent) > 0 ){
               $content =   $fileContent[0];
              }
             $xmlData[] = new WOFile("Job_$job_id.xlf",  $content);
           }
          
          }
       }
      }else{
        \Drupal::messenger()->addError(t('Cannot find WordsOnline provider settings. Please contact <a href="mailto:helpdesk@wordsonline.com"> helpdesk@wordsonline.com</a> to obtain WordsOnline provider settings.'));
      }
    }
    $modal_form = $this->formBuilder()->getForm('\Drupal\tmgmt_wordsonline\Form\ViewXlfForm',$xmlData);
    $render['form'] = $modal_form;  
    return $render;
}
}
