<?php

namespace Drupal\tmgmt_wordsonline\Form;
use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Database\Database;
use Drupal\Core\Url;
use Drupal\Core\Routing;
use Drupal\Component\Render\FormattableMarkup;
use Drupal\tmgmt_wordsonline\WordsOnlineConst;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Drupal\tmgmt\JobItemInterface;
use Drupal\tmgmt\JobInterface;
use Drupal\tmgmt\Entity\Job;
class OrderConfirmForm extends FormBase {
   const form_prefix ="<div class='order-progress-note d-none' style='text-align: initial;'><div class='container div-page-position' style='margin-top: 0px;'><div class='row ch-position' data-bind='with: orderDetail'><div class='ch-title'><span>Quote Detail</span></div>";
   const form_surfix ="</div></div></div></div></div><div class='container loading-quote'> <div class='loading'><p>loading quote</p><span></span></div></div>";
   const info_prefix ="<div class='wol-order-content'><div class='ch-summary-row-2'><span class='ch-row-left' style='width:35%'>Estimated Delivery Time</span><div class='ch-row-right' style='width:60%'>";
   const info_surfix ="</div></div><div class='ch-summary-row-2'><span class='ch-row-left'>Additional Preferences</span><div class='ch-row-right' style='line-height:1.5'><span class='step-2-right-targt'></span></div></div><div class='ch-summary-row-2'><span class='ch-row-left'>DTP Pagecount</span> <span class='ch-row-right' id='dtpPageCount'></span></div><div class='ch-summary-row-2'><span class='ch-row-left'>Word Count</span> <span class='ch-row-right' id='wordCount'></span></div><div class='ch-price-row'><span class='ch-row-left'>Order Total</span><div class='ch-row-right'><span class='ch-price-value' id='translationAmount'></span> <span class='ch-price-text'>translation token (s)</span></div></div><div class='ch-summary-row-2'><span class='ch-row-left'></span><div class='ch-row-right'><span class='ch-price-value' id='dtpAmount'></span> <span class='ch-price-text'>DTP token (s)</span></div></div><div class='ch-summary-row-2'><span class='ch-row-left'></span><div class='ch-row-right'><span class='ch-price-value' id ='mtAmount'></span> <span class='ch-price-text'>MT token (s)</span></div></div></div>";
   const action_prefix ="</div><div class='wol-order-action'>";
   const action_surfix ="</div>";

   /**
    * {@inheritdoc}
    */
    public function getFormId() {
      return 'wol_order_form';
    }
   
    /**
    * {@inheritdoc}
    */
    public function buildForm(array $form, FormStateInterface $form_state,$allowSubmmit ='true', $job_id = NULL) {    
      $database = \Drupal::database();
      $results =  $database->select('tmgmt_wordsonline_jobs', 'wol')
                           ->extend('\Drupal\Core\Database\Query\PagerSelectExtender')
                           ->condition('job_id', $job_id) 
                           ->fields('wol')
                           ->limit(1)
                           ->execute()
                           ->fetchAssoc();

      $request_name= null;
      $status ="";
      $rGuid="";
      if($results != null){
        $request_name=$results["request_name"];
        $status = $results["status"];
        $rGuid = $results["request_guid"];
      }
      $form['#prefix'] = OrderConfirmForm::form_prefix;
      $form['#suffix'] = "</div></div></div></div><div class='container loading-quote' data-job-id ='". $job_id."' onload='getQuote()'> <div class='loading'><p>loading quote</p><span></span></div>";
      $timezone = date_default_timezone_get();
      $cf = \Drupal::database()->query(WordsOnlineConst::SELECT_CONFIG)->fetchAssoc();
      if($cf != null){
        $auth["username"] = $cf["username"];
        $auth["password"] = $cf["password"];
        $auth["scope"] = $cf["scope"];
        $auth["grant_type"] =$cf["grant_type"];
        $response = getToken('POST', $auth);
        $response = json_decode($response, TRUE);
        $timezone =timezone_name_from_abbr($response['timezone']);      
      }
     
      $markup = new FormattableMarkup("<div class='wol-order-info'>",[]);
      $form['order_info'] = [
                '#markup' => $markup,
          ];
      $due_date =null;
      $job = Job::load($job_id);
      if($job){
        $due_date =  $job->getSetting('due_date');
        $content_type=$job->getSetting('content_type');
        $service_level =$job->getSetting('serice_level');
        $source_lang =$job->getSourceLangcode();
        $target_lang = $job->getTargetLangcode();
        $ret_lang = \Drupal::database()->query('SELECT  code,lang_name FROM tmgmt_wordsonline_support_languges')->fetchAll();
        foreach ($ret_lang as $row) {
          if($row->code == $source_lang){
           $source_lang = $row->lang_name;
          }
          if($row->code == $target_lang){
           $target_lang = $row->lang_name;
          }
        }
          $count =count($job->getItems());
          $markup = new FormattableMarkup("<div class='wol-order-info-summary'><div class='ch-summary-row-2'><span class='ch-row-left' style='width:35%'>Request Name</span><div class='ch-row-right' style='width:60%'>@name</div></div><div class='ch-summary-row-2'><span class='ch-row-left' style='width:35%'>Items To Translate</span><div class='ch-row-right' style='width:60%'>@count</div></div><div class='ch-summary-row-2'><span class='ch-row-left' style='width:35%'>Language Paire</span><div class='ch-row-right' style='width:60%'><span class='wol-lang-source'>@source_lang</span> &nbsp;&rsaquo;&nbsp;<span class='wol-btn'>@target_lang</span></div></div><div class='ch-summary-row-2'><span class='ch-row-left' style='width:35%'>Content Type</span><div class='ch-row-right' style='width:60%'>@content_type</div></div><div class='ch-summary-row-2'><span class='ch-row-left' style='width:35%'>Service Level</span><div class='ch-row-right' style='width:60%'>@service_level</div></div></div>",['@count'=>$count,'@source_lang'=> $source_lang,'@target_lang'=>$target_lang,'@service_level'=>$service_level,'@content_type'=>$content_type,'@name' => $request_name]);
        $form['order_info_detail'] = [
                '#markup' => $markup,
        ];
        }
        $markup = new FormattableMarkup(OrderConfirmForm::info_prefix,[]);
        $form['info_prefix'] = [
                    '#markup' => $markup,
          ];
        $form['estimate_date'] = [
          '#type' => 'date',
          '#format' => 'YYY-MM-DD h:mm A',
          '#required' => TRUE,
          '#value'=>$due_date,
          '#attributes' => [
          'min' => (new \DateTime("tomorrow", new \DateTimeZone($timezone)))->format('Y-m-d'),
          'onchange' => 'onDateChage(this)'
        ],
      ];
     
      $form['job_id'] = [
        '#type' => 'hidden',
        '#default_value' =>  $job_id,
        '#value'=>$job_id,
      ];
      $markup = new FormattableMarkup(OrderConfirmForm::info_surfix,[]);
      
      $form['info_surfix'] = [
                '#markup' => $markup,
          ];
      $auto_approve_quote = $job->getSetting('auto_approve_quote');
      if(!$auto_approve_quote){
        $auto_approve_quote = false;
      }
      if($auto_approve_quote == false && $allowSubmmit == 'true'){
        $form['actions']['#prefix']=OrderConfirmForm::action_prefix;
        $form['actions']['#surfix']=OrderConfirmForm::action_surfix;
        $form['actions']['cancel'] = [
          '#type' => 'submit',
          '#value' => $this->t('&larr;&nbsp;Back'),
          '#submit' => array([$this, 'setCancel']),
          '#name' => 'cancelOrrder' ,
          '#attributes'=>array('class'=> array('btn','btn-layout','btn-text')),
      ];
        $form['actions']['submit'] = [
          '#type' => 'submit',
          '#value' => $this->t('Confirm Order'),
          '#submit' =>array([$this, 'confirmOrder']),
          '#name' => 'confirmOrder' ,
          '#attributes'=>array('class'=> array('btn','btn-layout','ml-3','wol-btn')),
      ];
      }

      $form['#attached']['library'][] = 'tmgmt_wordsonline/wordsonline'; 
      return $form;
   
    }
  /**
   * check is weekend
   *
   */
  function isWeekend($date) {
      return (date('N', strtotime($date)) >= 6);
  }
  /**
  * approve quote
  *
  */
  public function confirmOrder(array $form, FormStateInterface $form_state) {
     
      $field = $form_state->getUserInput();         
      $job_id = $field['job_id'];
      $due_date =$field['estimate_date'];
      $req = \Drupal::database()->query("SELECT  * FROM tmgmt_wordsonline_jobs where job_id = :job_id LIMIT 1",[':job_id'=>$job_id])->fetchAssoc(); 
      if($req==null){
        \Drupal::messenger()->addMessage("Can not find job");
        return ;
      }
      $results = \Drupal::database()->query(WordsOnlineConst::SELECT_CONFIG)->fetchAssoc(); 
      if($results != null){
           $auth["username"] = $results["username"];
           $auth["password"] = $results["password"];
           $auth["scope"] = $results["scope"];
           $auth["grant_type"] =$results["grant_type"];
           $response = getToken('POST', $auth);
           $response = json_decode($response, TRUE);
           $token =$response['access_token'];
           $phpTime = date('Y-m-d H:i:s');
           $tz =timezone_name_from_abbr($response['timezone']);
           $timezone = new \DateTimeZone($tz);
           $offset = $timezone->getOffset(new \DateTime($phpTime));
           $offsetHours = round(($offset)/3600);
           if($offsetHours < 12){
              $offsetHours = 12 - $offsetHours;
            }
            else {
              $offsetHours = 1;
            }
            if($offsetHours > 23){
              $due_date =  date('Y-m-d', strtotime($due_date. ' + 1 days'));
            }
            $due_date = $due_date ." $offsetHours:05:00";
            $status =   ApproveQuote($req['request_guid'],"Approve",$due_date,$token);
            if($status ==1){
              $conn = \Drupal\Core\Database\Database::getConnection();
              $conn->update(WordsOnlineConst::JOB_TABLE)
                   ->condition('job_id', $job_id) 
                   ->fields(['status' => WordsOnlineConst::JOB_ORDERED])
                   ->execute();
              $url = new Url('tmgmt_wordsonline.wol_job', [], []);
              $url->setAbsolute();
              $response = new RedirectResponse($url->toString());
              $response->send();
              \Drupal::messenger()->addMessage("Order is confirmed!");
              return;
            }
            $url = new Url('tmgmt_wordsonline.wol_job', [], []);
            $url->setAbsolute();
            $response = new RedirectResponse($url->toString());
            $response->send();   
      }else{
        \Drupal::messenger()->addError(t('Cannot find WordsOnline provider settings. Please contact <a href="mailto:helpdesk@wordsonline.com"> helpdesk@wordsonline.com</a> to obtain WordsOnline provider settings.'));
      }
    
      return;
  }
  /**
   * cancel quote
   *
   */
  public function setCancel(array $form, FormStateInterface $form_state) {
 
    $field = $form_state->getUserInput();         
    $job_id = $field['job_id'];
    $due_date =$field['estimate_date'];
    $req = \Drupal::database()->query("SELECT  * FROM tmgmt_wordsonline_jobs where job_id = :job_id LIMIT 1",['job_id'=>$job_id])->fetchAssoc(); 
    if($req==null){
      $job = Job::load($job_id);
      if($job){
        $job->delete();
      }
      \Drupal::messenger()->addMessage("job cancelled");
      return ;
    }
    $results = \Drupal::database()->query(WordsOnlineConst::SELECT_CONFIG)->fetchAssoc(); 
    if($results != null){
        $auth["username"] = $results["username"];
        $auth["password"] = $results["password"];
        $auth["scope"] = $results["scope"];
        $auth["grant_type"] =$results["grant_type"];
        $response = getToken('POST', $auth);
        $response = json_decode($response, TRUE);
        $token =$response['access_token'];
        $status =   ApproveQuote($req['request_guid'],"Cancel",$due_date,$token);
        if($status ==1){
          $conn = \Drupal\Core\Database\Database::getConnection();
          $conn->update(WordsOnlineConst::JOB_TABLE)
               ->condition('job_id', $job_id) 
               ->fields(['status' => WordsOnlineConst::JOB_CANCELLED])
               ->execute();         
          $job = Job::load($job_id);
          if($job){
            $job->delete();
          }
          \Drupal::messenger()->addMessage("job cancelled");
          return;
        }else{
          \Drupal::messenger()->addError("can't cancel job");
          return ;
        }
          
    }else{
      \Drupal::messenger()->addError(t('Cannot find WordsOnline provider settings. Please contact <a href="mailto:helpdesk@wordsonline.com"> helpdesk@wordsonline.com</a> to obtain WordsOnline provider settings.'));
    }
   
  }
  /**
  * {@inheritdoc}
  */
  public function validateForm(array & $form, FormStateInterface $form_state) {
    $field = $form_state->getUserInput();         
    $due_date =$field['estimate_date'];
    if ($this-> isWeekend($due_date)) {
      $form_state->setErrorByName('estimate_date', t("Please kindly provide the available date for working day."));
    }
  }
   
  /**
  * {@inheritdoc}
  */
  public function submitForm(array & $form, FormStateInterface $form_state) {     
  }
   
}