<?php

namespace Drupal\tmgmt_wordsonline\Form;
use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Database\Database;
use Drupal\Core\Url;
use Drupal\Core\Routing;
use Drupal\Component\Render\FormattableMarkup;
use Drupal\tmgmt_wordsonline\WordsOnlineConst;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Drupal\tmgmt\JobItemInterface;
use Drupal\tmgmt\JobInterface;
use Drupal\tmgmt\Entity\Job;
use Drupal\tmgmt_wordsonline\Entity\WOFile;
class ViewXlfForm extends FormBase{
  /**
  * {@inheritdoc}
  */
  public function getFormId() {
    return 'wol_view_xlf_form';
  }
  /**
  * {@inheritdoc}
  */
  public function buildForm(array $form, FormStateInterface $form_state, $files = []) {
  $form['#prefix'] = "<div>";
  $form['#suffix'] ="</div>";
  $npath = \Drupal::service('extension.list.module')->getPath('tmgmt_wordsonline');
  $downloadIcon =  \Drupal::service('file_url_generator')->generateAbsoluteString($npath . '/icons/file-download.svg');
  
  $markup = new FormattableMarkup("<p><a class='button' href='#' onclick='downloadxlf()'><img src='@file' width ='18'/>Download</a></p><hr/>",[ '@file'=>$downloadIcon]);
  $form['info_prefix'] = [
      '#markup' => $markup,
  ];
     
  foreach($files as $fi){
    $form[$fi->FileName] = array(
      '#type' => 'details',
      '#title' => t($fi->FileName),
      '#group' => 'advanced',
    );
  $markup = new FormattableMarkup("<div><pre lang='xml' class='xlf-content' title='@title'>@xml</pre></div>",['@title' => $fi->FileName,  '@xml'=>$fi->Content]);
  $form[$fi->FileName][$fi->FileName] = [
      '#markup' => $markup,
    ];
  }
  $form['#attached']['library'][] = 'tmgmt_wordsonline/wordsonline'; 
  return $form;
}

  /**
  * {@inheritdoc}
  */
  public function validateForm(array & $form, FormStateInterface $form_state) {
     
  }
   
  /**
  * {@inheritdoc}
  */
  public function submitForm(array & $form, FormStateInterface $form_state) {
  
  }
}