<?php

namespace Drupal\tmgmt_wordsonline;
class WordsOnlineConst{
   const API_URL = "https://api.wordsonline.com/v4/";
   const Lang_Code_Field= "code";
   const Lang_Name_Field = "lang_name";
   const JOB_NEW= "NEW";
   const JOB_CREATED = "CREATED";
   const JOB_ORDERED = "ORDERED";
   const JOB_QUOTED = "QUOTED";
   const JOB_CANCELLED = "CANCELLED";
   const JOB_DELIVERED = "DELIVERED";
   const JOB_IMPORTED = "IMPORTED";
   const JOB_FINISHED = "FINISHED";
   const JOB_AUTOMATION_FAILED = "AUTOMATION FAILED";
   const CREATE_REQUEST_URL = 'requests/CreateRequest';
   const STATE_FINISHED = 5;
   const VIEW_JOB_LINK = '<a href=":url" target="_blank" class="btn"  title="View Job">View Job</a>';
   const VIEW_QUOTE_LINK = '<a href=":url" class="use-ajax btn"   data-dialog-type="modal" title="View Quote" >View Quote</a>';
   const REVIEW_LINK = '<a href=":url" target="_blank" class="btn" title="Review">Review</a>';
   const DOWNLOAD_LINK = '<a href=":url" class="use-ajax btn"   data-dialog-type="modal" title="download">Download</a>';
   const VIEW_XLF_LINK = 'admin/tmgmt/view-xlf?job_id=';
   const CONFIRM_ORDER_LINK = 'admin/tmgmt/wordsonline/wol-order?job_id=';
   const NOT_AVAILABLE ='N/A';
   const GET_PROJECT_URL= 'requests/GetProjectDetail?projectId=';
   const JOB_TABLE ='tmgmt_wordsonline_jobs';
   const SELECT_CONFIG = 'SELECT  * FROM tmgmt_wordsonline_configs LIMIT 1';
   const SEARCH_PLACEHOLDER = 'Search by request name, language, request id, project id.';
}
class WordsOnlineMessage{
    const NEW_ORDER_CREATED = "New order was created!";
    const FAILED_TO_CREATE_NEW_ORDER = "Failed to create new order!";
    const UNABLE_TO_CONNECT_SERVICES = 'Unable to connect to wordsonline service due to following error: @error';
    const UNABLE_TO_CONNECT_SERVICES_WITH_URL = 'Unable to connect to the wordsonline service due to following error: @error at @url';
    const AUTHEN_SAVED= 'The authentication data has been succesfully saved';
    const AUTHEN_ERROR = 'Username or password is not correct.';
    const NOT_FIND_PROVIDER_SETTING = 'Cannot find WordsOnline provider settings. Please contact helpdesk@wordsonline.com to obtain WordsOnline provider settings.';
}
class WordsOnlineState{
    const AutomationFailed = 'AutomationFailed';
    const QuoteSubmitted = 'QuoteSubmitted';
    const PaymentFailed = 'PaymentFailed';
    const PreparingQuote ='Preparing Quote';
}
class WordsOnlineStatus{
    const IMPORTED_STATUS= 'Imported';
    const IMPORT_FAIL_STATUS = 'ImportFailed';
    const FINISHED_STATUS = 'Finished';
    const Delivered = 'Delivered';
    const Unpaid = 'In Your Cart';
    const QuoteSubmitted = 'Quote Submitted';
}